//Arduino to RB Communications Protocol Implementation
//Arduino_Firmware.Pde
#define LED_Pin    13    //led pin  digital out
#define Pb_Pin      2    //pushbutton pin digital in
#define Pot_Pin     0    //A0 analog input
#define Dimmer_Pin  9    //PWM analog out
#define Speaker_Pin 10   //speaker with tone()
long blinker_timer,serial_timer;
long serial_timeout = 5000;
int received_bytecount=0;
char command[2];
char sendbuffer[5];
long blinkrate = 500;
int dimmer_level = 127;

int Notes [] =  //array of frequencies for sound generation
{
0,32.703,34.648,36.708,38.891,41.203,43.654,
  46.249,48.999,51.913,55.0,58.27,61.735,

65.406,69.296,73.416,77.782,82.407,87.307,
92.499,97.999,103.83,110.0,116.54,123.47,

130.81,138.59,146.83,155.56,164.1,174.61,
185.0,196.0,207.65,220.0,233.08,246.94,

261.63,277.18,293.66,311.13,329.63,349.23,    //middle C
369.99,391.99,415.31,440.0,466.16,493.88,

523.25,554.37,587.33,622.25,659.26,698.46,
739.99,783.99,830.61,880.0,932.33,987.77,

1046.5,1108.7,1174.7,1244.5,1318.5,1396.9,
1480.0,1568.0,1661.2,1760.0,1864.7,1975.5,

2093.0,2217.5,2349.3,2489.0,2637.0,2793.8,
2960.0,3136.0,3322.4,3520.0,3729.3,3951.1
};
//---------------------------------
void setup() 
{
  Serial.begin(115200);     //init serial comms
  Serial.flush();
  pinMode(LED_Pin, OUTPUT); 
  pinMode(Pb_Pin,  INPUT);
  blinker_timer = millis();
}
//---------------------------------
void Blink_LED()
{
 static int Mode = 0;
    if(millis()- blinker_timer > blinkrate)
    {
        Mode = !Mode;
        digitalWrite(LED_Pin,Mode);
        blinker_timer = millis();
    } 
}
//---------------------------------
void Read_ThreeBytes()
{
  sendbuffer[0] = !digitalRead(Pb_Pin);//push button status
                                       //inverted for active high
  sendbuffer[1] = 0;  //nothing for now
  sendbuffer[2] = 0;  //nothing for now
}
//---------------------------------
void SetSpeaker(int which_note)
{
  which_note = constrain(which_note,0,84); //array limits
  if(which_note > 0)
     tone(Speaker_Pin,Notes[which_note],5000);
  else
    noTone(Speaker_Pin);
}
//---------------------------------
void ReadPot()
{
   //set the last two bytes of the send buffer to the 
   //value of the pot using MSBFirst
   int x = analogRead(Pot_Pin);
   sendbuffer[3] = char(x >> 8);
   sendbuffer[4] = char(x);
}
//---------------------------------
void loop() 
{
  Blink_LED();          //blink on P13
  Read_ThreeBytes();    //read top three bytes of send buffer
  //SetSpeaker(10);  
  if(Serial.available() > 0)   //if byte available
  {
     command[received_bytecount++] = Serial.read();  //receive
     serial_timer = millis(); //start second byte timeout counter;
  }   
  if((serial_timer != 0) && (millis()-serial_timer > serial_timeout))
  {
     //second byte did not arrive on time
     received_bytecount  =  serial_timer = 0;
     command[0] = command[1] = 0;
     Serial.flush();
  }
  if(received_bytecount == 2)
  {
     //command and param have arrived
     switch(command[0])  //execute the command
     {
         case 2: ReadPot();break;
         case 3: analogWrite(Dimmer_Pin,command[1]);break;
         case 4: blinkrate = command[1]*10;break;   //blinker rate 255 steps of 10ms
         case 73: SetSpeaker(command[1]);break;
     }
     Serial.write((unsigned char *)sendbuffer,5);  //send the send buffer
     command[0] = command[1] = 0; 
     received_bytecount  =  serial_timer = 0;
  }  
}

