//Arduino to RB Communications Protocol Implementation
//Program_05.Bas.....runs with Arduino_Firmware.Pre
Port = 0   //change this as per your system
TCPS_IP = "192.168.0.196" \ TCPS_Port = 50001
tcpc_Connect(TCPS_IP,TCPS_Port)
#include ".\Instruments.Bas"
Main:
  gosub Initialization
  GoSub SetAllLevels
  while true
    call CheckMouseKeyboard()
    if Command == -1 then call DoPot()
    call SendCommand(Command,Parameter)
    if timer()-P1_Timer > sValue[1]  //blinker time out
       P1_State = !P1_State \if !sValue[1] then P1_State=0
       CircleWH 455,205,20,20,FactorColor(ConsToClr(yellow),-20),LEDState[P1_State*2]
       P1_Timer = timer() //reset timer
    endif
  wend
End
//------------------------------------------
Initialization:
  fnt = "Times New Roman"
  data LEDState;white,red,yellow
  setcommport Port,br115200   //set serial comms
  delay 2000
  xyText 390,100,"Last Command , Parameter",fnt,11,fs_Bold
  xystring 10,30,"Press the button on the Arduino and see the "+\
                 "corresponding LED light up"
  xyText 640,110,"If Lit => error",fnt,10,fs_Bold
  Spx = 700 \ Spy=170
  call DrawSpeaker(Spx,Spy)    
  data sLabel;"Dimmer Level","Blinker Duration"
  data sCommand; 3,4
  data sValue; 0,0,127,127
  for i=0 to 1
    xyString 240*i+30,175,sLabel[i]
    AddSlider "P"+i,10+240*i,200,200,0,255  
    SetSliderPos "P"+i,sValue[i+2]
    call MakeValue(i,sValue[i+2]) 
    xyText 80+240*i,245,MakeValue__Result,fnt,20,fs_Bold  
  next
  call DrawDimmer(sValue[2])
  Command = 0 \ Parameter = 0   
  P1_Timer = timer() \ P1_State = 0  
  LastSlider()  'clear any slider events
  GoSub  InitPot
  onSlider sHandler 
Return
//--------------------------------------------
SetAllLevels:
  for i=0 to 1 //force blinkers and dimmers to be set 
    //serialout sCommand[i],getsliderpos("P"+i)
    call TCP_SendCommand(sCommand[i],getsliderpos("P"+i))
  next
Return
//--------------------------------------------
sub MakeValue(which,Level)
  if which == 0  'dimmer
     n = 5*Level/255.0
     Level = Format(n,"0.000 V  ")
  elseif which == 1  'blink duration 
     n = Level*10
     Level = Format(n,"####0 ms  ")
  endif
  sValue[which] = n      
return Level
//--------------------------------------------
sub DrawDimmer(Level)
  //CircleWH 212,202,26,26,white,white
  CircleWH 205,198,37,37,white,white
  if !Level then return
  x = 3+(20*Level/255)/2
  Circle 225-x,215-x,225+x,215+x,red, RGB(Limit(Level,70,255),0,0)
return
//-----------------------------------------
sub SendCommand(Command,Parameter,&s)
  if Command < 0 then s="" \ return false
  xyText 450,120, Format(Command,"##0"+spaces(10))+\
            ",  "+Format(Parameter,"  ##0        "),_fnt,10,fs_Bold
  //ClearSerBuffer \ serialout Command,Parameter
  call TCP_SendCommand(Command,Parameter,s,x)
  _Command = -1 \ _Parameter = -1
  //serbytesin 5,s,x
  circlewh 600,100,30,30,red,LEDState[(x<5)]  //set the error LED
  if x < 5 then s = "" \ return false
  for i=0 to 2 
    circlewh 60+i*40,70,30,30,red,LEDState[Getstrbyte(s,3-i)&1]  //set the LEDs
  next
Return true
//--------------------------------------------
sub sHandler()
  ls = LastSlider()
  if left(ls,3) !="Pot"
    _Parameter = GetSliderPos(ls)
    n = tonumber(substring(ls,2))
    _Command = sCommand[n]
    if n == 0 then Call DrawDimmer(_Parameter)
    call MakeValue(n,_Parameter)
    xyText 80+240*n,245,MakeValue__Result,_fnt,20,fs_Bold
  endif
  onSlider sHandler
return
//--------------------------------------------
//-----------------------------------------
InitPot:
  xytext 400,290,"Change the Arduino Pot's positions and"+\
                             " observe the Slider",fnt,9,fs_bold
  AddSlider "Pot0",420,310,250,0,1024
  enableslider "Pot0",false
  xystring 410,350,GetSliderMin("Pot0") 
  xystring 650,350,GetSliderMax("Pot0") 
  xystring 520,350,Format(GetSliderPos("Pot0"),"####0")
Return
//----------------------------------------
sub DoPot()
  call SendCommand(2,0,s)
  if !SendCommand__Result then return
  P = (getstrbyte(s,4)<<8)+getstrbyte(s,5)
  setsliderpos "Pot0",P
  xystring 520,350,Format(GetSliderPos("Pot0"),"####0")
Return
//----------------------------------------
sub DrawSpeaker(Spx,Spy)
  rectanglewh Spx,Spy,20,40
  line Spx+20,Spy,Spx+30,Spy-10
  lineto Spx+30,Spy+50
  Lineto Spx+19,Spy+39
  xystring Spx+5,Spy+5,"+"
  floodfill Spx+2,Spy+2,gray
  floodfill Spx+22,Spy,gray
return
//--------------------------------------------
sub CheckMouseKeyboard()
    P= 1\ C = -1 \ readmouse x,y,mb
    if mb=1
       if within(x,_Spx,_Spx+30) && within(y,_Spy,_Spy+40) then C=73\P=80  //play note 80
    endif   
    if C == -1 then return
    call SendCommand(C,P)
return
//--------------------------------------------

